/*
 * JanelaPrincipal.java
 *
 * Created on 22/10/2009, 13:30:50
 */
package pintorj2d;

import java.awt.Cursor;
import java.io.File;
import javax.swing.JFileChooser;
import javax.swing.JOptionPane;

/**
 * Instituto Federal de Santa Catarina - IFSC - Campus São José
 * Disciplina: Programação Orientada a Objetos
 *
 * 
 * @author Emerson Ribeiro de Mello
 */
public class JanelaPrincipal extends javax.swing.JFrame {

    // para indicar qual a forma geométrica que o usuário selecionou
    public String formaGeometrica;

    /** Creates new form JanelaPrincipal */
    public JanelaPrincipal() {
        initComponents();
        formaGeometrica = "";

        // Fazendo com que a janela da aplicacao fique centralizada ao ser iniciada
        setLocationRelativeTo(null);

    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        buttonGroup1 = new javax.swing.ButtonGroup();
        jPBarraDeFerramentas = new javax.swing.JPanel();
        jTBRect = new javax.swing.JToggleButton();
        jTBElipse = new javax.swing.JToggleButton();
        jPanel3 = new javax.swing.JPanel();
        jLabel3 = new javax.swing.JLabel();
        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        jPAreaDeDesenho = new Area(this);
        jMenuBar1 = new javax.swing.JMenuBar();
        jMANovo = new javax.swing.JMenu();
        jMAAbrir = new javax.swing.JMenuItem();
        jMASalvar = new javax.swing.JMenuItem();
        jMASair = new javax.swing.JMenuItem();
        jSeparator1 = new javax.swing.JSeparator();
        jMenuItem4 = new javax.swing.JMenuItem();
        jMTela = new javax.swing.JMenu();
        jMTLimpar = new javax.swing.JMenuItem();
        jMSobre = new javax.swing.JMenu();
        jMSAutores = new javax.swing.JMenuItem();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("Pintor Vetorial J2D");
        setResizable(false);

        jPBarraDeFerramentas.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));

        buttonGroup1.add(jTBRect);
        jTBRect.setIcon(new javax.swing.ImageIcon(getClass().getResource("/pintorj2d/rect.png"))); // NOI18N
        jTBRect.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jTBRectMouseClicked(evt);
            }
        });
        jTBRect.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jTBRectActionPerformed(evt);
            }
        });

        buttonGroup1.add(jTBElipse);
        jTBElipse.setIcon(new javax.swing.ImageIcon(getClass().getResource("/pintorj2d/elipse.png"))); // NOI18N
        jTBElipse.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jTBElipseMouseClicked(evt);
            }
        });
        jTBElipse.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jTBElipseActionPerformed(evt);
            }
        });

        jPanel3.setBorder(javax.swing.BorderFactory.createEtchedBorder());

        jLabel3.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
        jLabel3.setText("Coord:");

        jLabel1.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabel1.setText("0");

        jLabel2.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabel2.setText("0");

        javax.swing.GroupLayout jPanel3Layout = new javax.swing.GroupLayout(jPanel3);
        jPanel3.setLayout(jPanel3Layout);
        jPanel3Layout.setHorizontalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel3Layout.createSequentialGroup()
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel3, javax.swing.GroupLayout.DEFAULT_SIZE, 84, Short.MAX_VALUE)
                    .addGroup(jPanel3Layout.createSequentialGroup()
                        .addContainerGap()
                        .addComponent(jLabel1, javax.swing.GroupLayout.PREFERRED_SIZE, 30, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(jLabel2, javax.swing.GroupLayout.PREFERRED_SIZE, 29, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap())
        );
        jPanel3Layout.setVerticalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel3Layout.createSequentialGroup()
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addComponent(jLabel3)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel1)
                    .addComponent(jLabel2))
                .addGap(35, 35, 35))
        );

        javax.swing.GroupLayout jPBarraDeFerramentasLayout = new javax.swing.GroupLayout(jPBarraDeFerramentas);
        jPBarraDeFerramentas.setLayout(jPBarraDeFerramentasLayout);
        jPBarraDeFerramentasLayout.setHorizontalGroup(
            jPBarraDeFerramentasLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPBarraDeFerramentasLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPBarraDeFerramentasLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPBarraDeFerramentasLayout.createSequentialGroup()
                        .addComponent(jTBRect)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jTBElipse))
                    .addComponent(jPanel3, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addContainerGap())
        );
        jPBarraDeFerramentasLayout.setVerticalGroup(
            jPBarraDeFerramentasLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPBarraDeFerramentasLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPBarraDeFerramentasLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jTBRect)
                    .addComponent(jTBElipse))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 254, Short.MAX_VALUE)
                .addComponent(jPanel3, javax.swing.GroupLayout.PREFERRED_SIZE, 62, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );

        jPAreaDeDesenho.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseEntered(java.awt.event.MouseEvent evt) {
                jPAreaDeDesenhoMouseEntered(evt);
            }
        });

        javax.swing.GroupLayout jPAreaDeDesenhoLayout = new javax.swing.GroupLayout(jPAreaDeDesenho);
        jPAreaDeDesenho.setLayout(jPAreaDeDesenhoLayout);
        jPAreaDeDesenhoLayout.setHorizontalGroup(
            jPAreaDeDesenhoLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 576, Short.MAX_VALUE)
        );
        jPAreaDeDesenhoLayout.setVerticalGroup(
            jPAreaDeDesenhoLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 384, Short.MAX_VALUE)
        );

        jMANovo.setMnemonic('a');
        jMANovo.setText("Arquivo");

        jMAAbrir.setMnemonic('n');
        jMAAbrir.setText("Novo");
        jMAAbrir.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMAAbrirActionPerformed(evt);
            }
        });
        jMANovo.add(jMAAbrir);

        jMASalvar.setMnemonic('a');
        jMASalvar.setText("Abrir");
        jMASalvar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMASalvarActionPerformed(evt);
            }
        });
        jMANovo.add(jMASalvar);

        jMASair.setMnemonic('s');
        jMASair.setText("Salvar");
        jMASair.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMASairActionPerformed(evt);
            }
        });
        jMANovo.add(jMASair);
        jMANovo.add(jSeparator1);

        jMenuItem4.setMnemonic('r');
        jMenuItem4.setText("Sair");
        jMenuItem4.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem4ActionPerformed(evt);
            }
        });
        jMANovo.add(jMenuItem4);

        jMenuBar1.add(jMANovo);

        jMTela.setMnemonic('t');
        jMTela.setText("Tela");

        jMTLimpar.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_SPACE, java.awt.event.InputEvent.CTRL_MASK));
        jMTLimpar.setMnemonic('l');
        jMTLimpar.setText("Limpar");
        jMTLimpar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMTLimparActionPerformed(evt);
            }
        });
        jMTela.add(jMTLimpar);

        jMenuBar1.add(jMTela);

        jMSobre.setMnemonic('s');
        jMSobre.setText("Sobre");

        jMSAutores.setMnemonic('a');
        jMSAutores.setText("Autores");
        jMSAutores.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMSAutoresActionPerformed(evt);
            }
        });
        jMSobre.add(jMSAutores);

        jMenuBar1.add(jMSobre);

        setJMenuBar(jMenuBar1);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addComponent(jPBarraDeFerramentas, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPAreaDeDesenho, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jPBarraDeFerramentas, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
            .addComponent(jPAreaDeDesenho, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jTBRectActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jTBRectActionPerformed
        // fazendo coerção ou cast se preferir
        ((Area) this.jPAreaDeDesenho).zerarCoordenadas();

        this.formaGeometrica = "retangulo";
    }//GEN-LAST:event_jTBRectActionPerformed

    private void jTBRectMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jTBRectMouseClicked
        // TODO add your handling code here:
    }//GEN-LAST:event_jTBRectMouseClicked

    private void jTBElipseMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jTBElipseMouseClicked
        // TODO add your handling code here:
    }//GEN-LAST:event_jTBElipseMouseClicked

    private void jTBElipseActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jTBElipseActionPerformed
        // fazendo coerção ou cast se preferir
        ((Area) this.jPAreaDeDesenho).zerarCoordenadas();

        this.formaGeometrica = "elipse";
    }//GEN-LAST:event_jTBElipseActionPerformed

    private void jMTLimparActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMTLimparActionPerformed
        // fazendo coerção ou cast se preferir
        ((Area) this.jPAreaDeDesenho).limparImagem();
    }//GEN-LAST:event_jMTLimparActionPerformed

    private void jMASalvarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMASalvarActionPerformed
        
        // Tutorial sobre o uso da classe JFileChooser
        // http://java.sun.com/docs/books/tutorial/uiswing/components/filechooser.html

        JFileChooser fc = new JFileChooser();
        int retorno = fc.showOpenDialog(this);

        // se um arquivo foi selecionado
        if (retorno == JFileChooser.APPROVE_OPTION) {
            File arquivo = fc.getSelectedFile();
            JOptionPane.showMessageDialog(this, arquivo.getName(), "O arquivo selecionado foi:", JOptionPane.INFORMATION_MESSAGE);
            // Falta carregar todas as imagens na tela a partir do arquivo TEXTO
        }

    }//GEN-LAST:event_jMASalvarActionPerformed

    private void jMSAutoresActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMSAutoresActionPerformed

        // criando uma janela JDialog
        new util.Sobre(this, rootPaneCheckingEnabled).setVisible(true);
    }//GEN-LAST:event_jMSAutoresActionPerformed

    private void jMASairActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMASairActionPerformed
        
        // Tutorial sobre o uso da classe JFileChooser
        //http://java.sun.com/docs/books/tutorial/uiswing/components/filechooser.html

        JFileChooser fc = new JFileChooser();
        int retorno = fc.showSaveDialog(this);

        // se um arquivo foi selecionado
        if (retorno == JFileChooser.APPROVE_OPTION) {
            File arquivo = fc.getSelectedFile();

            JOptionPane.showMessageDialog(this, arquivo.getName(), "O arquivo selecionado foi:", JOptionPane.INFORMATION_MESSAGE);
            // Falta salvar todas as imagens da tela em um arquivo TEXTO
        }

    }//GEN-LAST:event_jMASairActionPerformed

    private void jMenuItem4ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem4ActionPerformed

        // sai do aplicativo
        System.exit(0);
    }//GEN-LAST:event_jMenuItem4ActionPerformed

    private void jMAAbrirActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMAAbrirActionPerformed
        // antes de fazer um novo, seria interessante pedir uma confirmação
        // para o usuário. Ex: Você realmente quer fazer o novo projeto?
        // limpando a tela
        ((Area) this.jPAreaDeDesenho).limparImagem();
    }//GEN-LAST:event_jMAAbrirActionPerformed

    private void jPAreaDeDesenhoMouseEntered(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jPAreaDeDesenhoMouseEntered
        // se alguma forma geométrica já estiver escolhida
        // então altera o cursor do mouse
        if (!this.formaGeometrica.equals("")){
            jPAreaDeDesenho.setCursor(new Cursor(Cursor.CROSSHAIR_CURSOR));
        }
    }//GEN-LAST:event_jPAreaDeDesenhoMouseEntered

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {

            public void run() {
                new JanelaPrincipal().setVisible(true);
            }
        });
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.ButtonGroup buttonGroup1;
    public javax.swing.JLabel jLabel1;
    public javax.swing.JLabel jLabel2;
    public javax.swing.JLabel jLabel3;
    private javax.swing.JMenuItem jMAAbrir;
    private javax.swing.JMenu jMANovo;
    private javax.swing.JMenuItem jMASair;
    private javax.swing.JMenuItem jMASalvar;
    private javax.swing.JMenuItem jMSAutores;
    private javax.swing.JMenu jMSobre;
    private javax.swing.JMenuItem jMTLimpar;
    private javax.swing.JMenu jMTela;
    private javax.swing.JMenuBar jMenuBar1;
    private javax.swing.JMenuItem jMenuItem4;
    private javax.swing.JPanel jPAreaDeDesenho;
    private javax.swing.JPanel jPBarraDeFerramentas;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JSeparator jSeparator1;
    private javax.swing.JToggleButton jTBElipse;
    private javax.swing.JToggleButton jTBRect;
    // End of variables declaration//GEN-END:variables
}
